/* Sistemas Integrados TEKNISA
   Gesto de qualificao

Nome: 8520_QFOSTPO.sql

Descrio:
Duplica um cadastro de qualificao de marca por produto e cria testes de
produto para as qualificaes duplicadas.

Criao:
15/08/2000 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE PROCEDURE DUPLICA_QFOMARPROD
   (P_PRODORIGEM  IN PRODUTO.CDARVPROD%TYPE,
    P_PRODINI     IN PRODUTO.CDARVPROD%TYPE,
    P_PRODFIN     IN PRODUTO.CDARVPROD%TYPE,
    P_CDMARCA     IN VARCHAR2,
    P_ATUALIQUALI IN VARCHAR2,
    P_GERATESTE   IN VARCHAR2,
    P_ATUALITESTE IN VARCHAR2) IS
 V_TCDMARCA   VARCHAR2(1);
 V_PROXTESTE  VARCHAR2(20);
 V_DATATESTE  QFOMARPROD.DTTESTEQUA%TYPE;
BEGIN
   IF P_CDMARCA IS NULL THEN
      V_TCDMARCA := 'T';
   END IF;
/* C_PRODDEST -> RETORNA A LISTA DOS PRODUTOS DE DESTINO */
   FOR C_PRODDEST IN
   (SELECT
       PRODUTO.CDPRODUTO,
       QFOMARPROD.CDMARCA,
       QFOMARPROD.CDPRODUTO AS PRODORIGEM,
       QFOMARPROD.IDAPRMARPRO,
       QFOMARPROD.IDAUTMARPRO,
       QFOMARPROD.DTVALAPROVA,
       QFOMARPROD.VRRENDATU,
       QFOMARPROD.IDRENMARPRO,
       QFOMARPROD.NRTESTEPROD,
       QFOMARPROD.DTTESTEQUA
    FROM
       QFOMARPROD,
       PRODUTO,
       PRODUTO P
    WHERE
       (PRODUTO.CDARVPROD BETWEEN P_PRODINI AND P_PRODFIN) AND
       (PRODUTO.CDPRODESTO IS NOT NULL) AND
       (P.CDPRODUTO = QFOMARPROD.CDPRODUTO) AND
       (P.CDARVPROD = P_PRODORIGEM) AND
       (INSTR(P_CDMARCA, QFOMARPROD.CDMARCA)<> 0 OR V_TCDMARCA = 'T'))
   LOOP
/* CADASTRA MARCA POR PRODUTO SE NO EXISTIR */
      V_DATATESTE := C_PRODDEST.DTTESTEQUA;
      INSERT INTO MARCPROD
         (CDPRODUTO, CDMARCA)
         (SELECT
             CDPRODUTO,
             C_PRODDEST.CDMARCA
          FROM
             PRODUTO
          WHERE
             PRODUTO.CDPRODUTO = C_PRODDEST.CDPRODUTO AND
             NOT EXISTS (SELECT
                            MARCPROD.CDMARCA,
                            MARCPROD.CDPRODUTO
                         FROM
                            MARCPROD,
                            PRODUTO PR
                         WHERE
                            MARCPROD.CDPRODUTO = PR.CDPRODUTO AND
                            MARCPROD.CDMARCA = C_PRODDEST.CDMARCA AND
                            PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%'));
      INSERT INTO MARCPRODCOMP
         (CDPRODUTO, CDMARCA, CDPRMARCOMPL)
         (SELECT
             CDPRODUTO,
             C_PRODDEST.CDMARCA,
             CDPRODUTO
          FROM
             PRODUTO
          WHERE
             PRODUTO.CDPRODUTO = C_PRODDEST.CDPRODUTO AND
             NOT EXISTS (SELECT
                            MARCPRODCOMP.CDMARCA,
                            MARCPRODCOMP.CDPRODUTO
                         FROM
                            MARCPRODCOMP,
                            PRODUTO PR
                         WHERE
                            MARCPRODCOMP.CDPRODUTO = PR.CDPRODUTO AND
                            MARCPRODCOMP.CDMARCA = C_PRODDEST.CDMARCA AND
                            PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%'));
      BEGIN
         V_PROXTESTE := NULL;
         V_DATATESTE := NULL;
         IF P_ATUALITESTE = 'S' THEN
            IF C_PRODDEST.NRTESTEPROD IS NULL THEN
               UPDATE TESTEPROD
               SET DTVALAPRTEST = C_PRODDEST.DTVALAPROVA,
                   IDMARCAPRTES = C_PRODDEST.IDAPRMARPRO
               WHERE
                   CDPRODUTO = C_PRODDEST.CDPRODUTO AND
                   CDMARCA   = C_PRODDEST.CDMARCA AND
                   EXISTS (SELECT CDPRODUTO
                           FROM TESTEPROD T
                           WHERE T.CDPRODUTO = C_PRODDEST.PRODORIGEM AND
                                 T.CDMARCA = TESTEPROD.CDMARCA);
            ELSE
               UPDATE TESTEPROD
               SET  DTTESTE = SYSDATE,
                    CDFORNECED = (SELECT CDFORNECED
                                  FROM TESTEPROD
                                  WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    NMRESPTESTE = (SELECT NMRESPTESTE
                                   FROM TESTEPROD
                                   WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDMARCAPRTES = (SELECT IDMARCAPRTES
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    DTVALAPRTEST = (SELECT DTVALAPRTEST
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    VRRENDATUTES = (SELECT VRRENDATUTES
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    DSRENDATUAL  = (SELECT DSRENDATUAL
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDTIPREN     = (SELECT IDTIPREN
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    NMFABROPCTES = (SELECT NMFABROPCTES
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    NMTIPOEMBAL  = (SELECT NMTIPOEMBAL
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDEMBDATVAL  = (SELECT IDEMBDATVAL
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    DSREGISTTEST = (SELECT DSREGISTTEST
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDASPVISUAL  = (SELECT IDASPVISUAL
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDASPCOR     = (SELECT IDASPCOR
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDASPODOR    = (SELECT IDASPODOR
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDASPSABOR   = (SELECT IDASPSABOR
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDASPTEXT    = (SELECT IDASPTEXT
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDTESTBROM   = (SELECT IDTESTBROM
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDPRATEMB    = (SELECT IDPRATEMB
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    IDPRATMANIP  = (SELECT IDPRATMANIP
                                    FROM TESTEPROD
                                    WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD),
                    HRTEMPOELAB   = (SELECT HRTEMPOELAB
                                     FROM TESTEPROD
                                     WHERE NRTESTEPROD = C_PRODDEST.NRTESTEPROD)
               WHERE
                  CDPRODUTO = C_PRODDEST.CDPRODUTO AND
                  CDMARCA   = C_PRODDEST.CDMARCA;
            END IF;
         END IF;
         IF SQL%NOTFOUND THEN
            IF P_GERATESTE = 'S' THEN
               NOVO_CODIGO('TESTEPROD', V_PROXTESTE);
               INSERT INTO TESTEPROD
                  (NRTESTEPROD,  DTTESTE,      CDPRODUTO,
                   CDMARCA,      CDFORNECED,   NMRESPTESTE,
                   IDMARCAPRTES, DTVALAPRTEST, VRRENDATUTES,
                   DSRENDATUAL,  IDTIPREN,     NMFABROPCTES,
                   NMTIPOEMBAL,  IDEMBDATVAL,  DSREGISTTEST,
                   IDASPVISUAL,  IDASPCOR,     IDASPODOR,
                   IDASPSABOR,   IDASPTEXT,    IDTESTBROM,
                   IDPRATEMB,    IDPRATMANIP,  HRTEMPOELAB)
                  (SELECT
                      SUBSTR(V_PROXTESTE, 11, 10),  SYSDATE,      C_PRODDEST.CDPRODUTO,
                      C_PRODDEST.CDMARCA, CDFORNECED, NMRESPTESTE,
                      IDMARCAPRTES, DTVALAPRTEST, VRRENDATUTES,
                      DSRENDATUAL,  IDTIPREN,     NMFABROPCTES,
                      NMTIPOEMBAL,  IDEMBDATVAL,  DSREGISTTEST,
                      IDASPVISUAL,  IDASPCOR,     IDASPODOR,
                      IDASPSABOR,   IDASPTEXT,    IDTESTBROM,
                      IDPRATEMB,    IDPRATMANIP,  HRTEMPOELAB
                   FROM
                      TESTEPROD
                   WHERE
                      NRTESTEPROD = C_PRODDEST.NRTESTEPROD);
               IF SQL%ROWCOUNT = 0 THEN
                  V_PROXTESTE := NULL;
                  V_DATATESTE := NULL;
               ELSE
                  IF P_ATUALIQUALI = 'N' THEN
                     UPDATE QFOMARPROD
                     SET NRTESTEPROD = SUBSTR(V_PROXTESTE, 11, 10)
                     WHERE CDPRODUTO = C_PRODDEST.CDPRODUTO AND
                           CDMARCA = C_PRODDEST.CDMARCA;
                  END IF;
               END IF;
      	    END IF;
         END IF;
      END;
      BEGIN
         IF P_ATUALIQUALI = 'S' THEN
            UPDATE QFOMARPROD
            SET IDAPRMARPRO = C_PRODDEST.IDAPRMARPRO,
                IDAUTMARPRO = C_PRODDEST.IDAUTMARPRO,
                DTVALAPROVA = C_PRODDEST.DTVALAPROVA,
                VRRENDATU   = C_PRODDEST.VRRENDATU,
                IDRENMARPRO = C_PRODDEST.IDRENMARPRO,
                NRTESTEPROD = NVL(SUBSTR(V_PROXTESTE, 11, 10),NRTESTEPROD),
                DTTESTEQUA  = NVL(V_DATATESTE,DTTESTEQUA)
            WHERE
               QFOMARPROD.CDPRODUTO = C_PRODDEST.CDPRODUTO AND
               QFOMARPROD.CDMARCA   = C_PRODDEST.CDMARCA;

            IF SQL%NOTFOUND THEN
               INSERT INTO QFOMARPROD
               (CDMARCA,
                CDPRODUTO,
                IDAPRMARPRO,
                IDAUTMARPRO,
                DTVALAPROVA,
                VRRENDATU,
                IDRENMARPRO,
                NRTESTEPROD,
                DTTESTEQUA)
                VALUES
                   (C_PRODDEST.CDMARCA,
                    C_PRODDEST.CDPRODUTO,
                    C_PRODDEST.IDAPRMARPRO,
                    C_PRODDEST.IDAUTMARPRO,
                    C_PRODDEST.DTVALAPROVA,
                    C_PRODDEST.VRRENDATU,
                    C_PRODDEST.IDRENMARPRO,
                    DECODE (P_GERATESTE,
                            'S', SUBSTR(V_PROXTESTE, 11, 10),
                            NULL),
                    DECODE (P_GERATESTE,
                            'S', V_DATATESTE,
                            NULL));
            END IF;
         END IF;
         IF P_ATUALIQUALI = 'N' THEN
            INSERT INTO QFOMARPROD
               (CDMARCA, CDPRODUTO, IDAPRMARPRO,
                IDAUTMARPRO, DTVALAPROVA, VRRENDATU,
                IDRENMARPRO, NRTESTEPROD, DTTESTEQUA)
               (SELECT
                   C_PRODDEST.CDMARCA,
                   PRODUTO.CDPRODUTO,
                   C_PRODDEST.IDAPRMARPRO,
                   C_PRODDEST.IDAUTMARPRO,
                   C_PRODDEST.DTVALAPROVA,
                   C_PRODDEST.VRRENDATU,
                   C_PRODDEST.IDRENMARPRO,
                   DECODE (P_GERATESTE,
                          'S', SUBSTR(V_PROXTESTE, 11, 10),
                           NULL),
                   DECODE (P_GERATESTE,
                          'S', V_DATATESTE,
                           NULL)
                FROM
                   PRODUTO
                WHERE
                   PRODUTO.CDPRODUTO = C_PRODDEST.CDPRODUTO AND
                   NOT EXISTS (SELECT 1
                               FROM QFOMARPROD, PRODUTO PR
                               WHERE QFOMARPROD.CDPRODUTO = PR.CDPRODUTO AND
                                     QFOMARPROD.CDMARCA   = C_PRODDEST.CDMARCA AND
                                     PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%'));
         END IF;
      END;
   END LOOP;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('DUPLICA_QFOMARPROD','4.11.146'); END;
/

